//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "convert_utf8_to_utf16.h"

#include "wsq_demo_main_form.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{

   hBitmap = (HBITMAP)NULL;
   comment_text = (char*) NULL; // It is important to initialize to NULL to avoid crashing
   comment_text2 = (char*)NULL; // It is important to initialize to NULL to avoid crashing


   // returns a handle to the DLL, otherwise NULL
   hWSQ_library = LoadLibraryW(L"WSQ_library.dll");

   if (hWSQ_library == NULL)
   {Application->MessageBox( "Error: WSQ_library.dll not found", "Error", MB_OK);}
   pRegisterWSQ = (RegisterWSQ) GetProcAddress(hWSQ_library, "_RegisterWSQ");
   pCreateBMPFromFile = (CreateBMPFromFile) GetProcAddress(hWSQ_library, "_CreateBMPFromFile");
   pSaveBMPToFile = (SaveBMPToFile) GetProcAddress(hWSQ_library, "_SaveBMPToFile");
   pCreateBMPFromWSQByteArray = (CreateBMPFromWSQByteArray) GetProcAddress(hWSQ_library, "_CreateBMPFromWSQByteArray");
   pSaveWSQByteArrayToImageFile = (SaveWSQByteArrayToImageFile) GetProcAddress(hWSQ_library, "_SaveWSQByteArrayToImageFile");
   pSetShowFilePropertiesDialog = (SetShowFilePropertiesDialog) GetProcAddress(hWSQ_library, "_SetShowFilePropertiesDialog");
   pShowFileConverter = (ShowFileConverter) GetProcAddress(hWSQ_library, "_ShowFileConverter");
   pWSQ_decode_stream = (WSQ_decode_stream) GetProcAddress(hWSQ_library, "_WSQ_decode_stream");
   pWSQ_encode_stream = (WSQ_encode_stream) GetProcAddress(hWSQ_library, "_WSQ_encode_stream");
   pConvertHBITMAPtoGrayScale256 = (ConvertHBITMAPtoGrayScale256) GetProcAddress(hWSQ_library, "_ConvertHBITMAPtoGrayScale256");
   pSaveHBITMAPtoFileAsGrayScale256BMP = (SaveHBITMAPtoFileAsGrayScale256BMP) GetProcAddress(hWSQ_library, "_SaveHBITMAPtoFileAsGrayScale256BMP");



   if (pRegisterWSQ == NULL)
   {Application->MessageBox( "Error: GetProcAddress of RegisterWSQ failed", "Error", MB_OK );}
   if (pCreateBMPFromFile == NULL)
   {Application->MessageBox( "Error: GetProcAddress of SaveBMPToFile failed", "Error", MB_OK );}
   if (pSaveBMPToFile == NULL)
   {Application->MessageBox( "Error: GetProcAddress of CreateBMPFromFile failed", "Error", MB_OK );}
   if (pCreateBMPFromWSQByteArray == NULL)
   {Application->MessageBox( "Error: GetProcAddress of CreateBMPFromWSQByteArray failed", "Error", MB_OK );}
   if (pSaveWSQByteArrayToImageFile == NULL)
   {Application->MessageBox( "Error: GetProcAddress of SaveWSQByteArrayToImageFile failed", "Error", MB_OK );}
   if (pSetShowFilePropertiesDialog == NULL)
   {Application->MessageBox( "Error: GetProcAddress of SetShowFilePropertiesDialog failed", "Error", MB_OK );}
   if (pShowFileConverter == NULL)
   {Application->MessageBox( "Error: GetProcAddress of ShowFileConverter failed", "Error", MB_OK );}
   if (pWSQ_decode_stream == NULL)
   {Application->MessageBox( "Error: GetProcAddress of WSQ_decode_stream failed", "Error", MB_OK );}
   if (pWSQ_encode_stream == NULL)
   {Application->MessageBox( "Error: GetProcAddress of WSQ_encode_stream failed", "Error", MB_OK );}
   if (pConvertHBITMAPtoGrayScale256 == NULL)
   {Application->MessageBox( "Error: GetProcAddress of ConvertHBITMAPtoGrayScale256 failed", "Error", MB_OK );}
   if (pSaveHBITMAPtoFileAsGrayScale256BMP == NULL)
   {Application->MessageBox( "Error: GetProcAddress of SaveHBITMAPtoFileAsGrayScale256BMP failed", "Error", MB_OK );}




}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OpenButtonClick(TObject *Sender)
{

	const wchar_t* strFilter = L"All images\0*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;"
L"*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;"
L"*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp\0"
L"FBI Wavelet Scalar Quantization (*.wsq)\0*.wsq\0"
L"Windows bitmaps (*.bmp)\0*.bmp\0"
L"Macintosh TIFF images (*.tiff)\0*.tiff\0"
L"PC TIFF images (*.tif)\0*.tif\0"
L"JPG images (*.jpg)\0*.jpg\0"
L"JPEG-2000 Part-1 (*.jp2)\0*.jp2\0"
L"JPEG-2000 Code Stream (*.jpc)\0*.jpc\0"
L"JPE images (*.jpe)\0*.jpe\0"
L"JPEG images (*.jpeg)\0*.jpeg\0"
L"Portable network graphic images (*.png)\0*.png\0"
L"Compuserve Graphic Interchange Format(*.gif)\0*gif\0"
L"Paintshop Pro images (*.psp)\0*.psp\0"
L"JFIF images (*.jfif)\0*.jfif\0"
L"Run length encoded Windows bitmaps (*.rle)\0*.rle\0"
L"Device independant Windows bitmaps (*.dib)\0*.dib\0"
L"Truevision images (*.win)\0*.win\0"
L"Truevision images (*.vst)\0*.vst\0"
L"Truevision images (*.vda)\0*.vda\0"
L"Truevision images (*.tga)\0*.tga\0"
L"Truevision images (*.icb)\0*.icb\0"
L"GFI fax images (*.fax)\0*.fax\0"
L"Encapsulated Postscript images (*.eps)\0*.eps\0"
L"ZSoft Paintbrush images (*.pcx)\0*.pcx\0"
L"ZSoft Paintbrush images (*.pcc)\0*.pcc\0"
L"Word 5.x screen capture images (*.scr)\0*.scr\0"
L"Alias/Wavefront images (*.rpf)\0*.rpf\0"
L"Alias/Wavefront images (*.rla)\0*.rla\0"
L"SGI true color images (*.sgi)\0*.sgi\0"
L"SGI true color images with alpha (*.rgba)\0*.rgba\0"
L"SGI true color images (*.rgb)\0*.rgb\0"
L"SGI black/white images (*.bw)\0*.bw\0"
L"Photoshop images (*.psd)\0*.psd\0"
L"Photoshop images (*.pdd)\0*.pdd\0"
L"Portable pixel map images (*.ppm)\0*.ppm\0"
L"Portable gray map images (*.pgm)\0*.pgm\0"
L"Portable bitmap images (*.pbm)\0*.pbm\0"
L"Autodesk images (*.cel)\0*.cel\0"
L"Autodesk images (*.pic)\0*.pic\0"
L"Kodak Photo-CD images (*.pcd)\0*.pcd\0"
L"Dr. Halo images (*.cut)\0*.cut\0"
L"Amiga Bitmap Graphic (8 bits)\0*.iff\0"
L"Windows icons (*.ico)\0*.ico\0"
L"Windows metafiles (*.wmf)\0*.wmf\0"
L"Windows enhanced meta files (*.emf)\0*.emf";


    wchar_t szFileName[MAX_PATH] = { 0 };
    OPENFILENAMEW ofn;
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = 0;
    ofn.hInstance = 0;
    ofn.lpstrFilter = strFilter;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrDefExt= 0;
    ofn.lpstrFile = szFileName;
    ofn.Flags = OFN_FILEMUSTEXIST | OFN_READONLY;

      if (!GetOpenFileNameW(&ofn)) {
         return ; // cancel open file
      }


    // Take and use Handle of HBitmap directly from WSQ image library DLL.
    // If the WSQ image library is called to load or save another picture, you will lose the current image     
	hBitmap = (HBITMAP)NULL;
    hBitmap = (pCreateBMPFromFile)(convert_utf16_to_utf8((char*)szFileName));

        if ( hBitmap )
        {
            SaveButton->Enabled = true;
// Take and use Handle of HBitmap directly from WSQ image library DLL.
// If the WSQ image library is called to load or save another picture, you will lose the current image
          OutputImage->Picture->Bitmap->Handle = hBitmap;

//Make a copy of hBitmap into OutputImage->Picture
//            OutputImage->Picture->Bitmap->Handle  = (HBITMAP)CopyImage((HANDLE)hBitmap, IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG);

            OutputImage->Width = OutputImage->Picture->Bitmap->Width;
            OutputImage->Height = OutputImage->Picture->Bitmap->Height;
            Invalidate();
        }
        else
        {
            Application->MessageBox("Unable to load file", "WSQ library error", MB_OK | MB_ICONERROR );
        } 





}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveButtonClick(TObject *Sender)
{



	const wchar_t* strFilter = L"WSQ Files (*.wsq)\0*.wsq\0"
L"Windows BMP (*.bmp)\0*.bmp\0"
L"TIFF Files (*.tif)\0*.tif\0"
L"PNG Files (*.png)\0*.png\0"
L"JPEG Files (*.jpg)\0*.jpg\0"
L"Targa Files (*.tga)\0*.tga\0"
L"SGI Files (*.rgb)\0*.rgb\0"
L"JPEG-2000 Part-1 (*.jp2)\0*.jp2\0"
L"JPEG-2000 Code Stream (*.jpc)\0*.jpc\0"
L"PBM - Portable Bitmap Format (*.pbm)\0*.pbm\0"
L"PGM - Portable Graymap Format (*.pgm)\0*.pgm\0"
L"PPM - Portable Pixmap Format (*.ppm)\0*.ppm";

                            
    wchar_t szFileName[MAX_PATH] = { 0 };
    OPENFILENAMEW ofn;
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = 0;
    ofn.hInstance = 0;
    ofn.lpstrFilter = strFilter;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrDefExt= 0;
    ofn.lpstrFile = szFileName;
    if (!GetSaveFileNameW(&ofn)) {
       return ; // cancel open file
    }


		
    (pSetShowFilePropertiesDialog)(1);
    (pSaveBMPToFile)(OutputImage->Picture->Bitmap->Handle, convert_utf16_to_utf8((char*)szFileName), ofn.nFilterIndex);


}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RegisterButtonClick(TObject *Sender)
{

(pRegisterWSQ)();

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{

Left = (Screen->Width - Width)/2;
Top = (Screen->Height - Height)/2;


}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WSQtoStreamButtonClick(TObject *Sender)
{


 	const wchar_t* strFilter = L"WSQ Files (*.wsq)\0*.wsq\0\0";
	wchar_t szFileName[MAX_PATH] = { 0 };
    OPENFILENAMEW ofn;
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = 0;
    ofn.hInstance = 0;
    ofn.lpstrFilter = strFilter;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrDefExt= 0;
    ofn.lpstrFile = szFileName;
    ofn.Flags = OFN_FILEMUSTEXIST | OFN_READONLY;

    if (!GetOpenFileNameW(&ofn)) {
       return ; // cancel open file
    }
	


	int handle = _wopen(szFileName, 0);
    if (!handle) {
       MessageBoxW(0, L"Cannot open file", L"Error", 0);
       return;
    }
    int ret = 0;
    if((ret = filelength(handle)) < 0) {
            MessageBoxW( 0, L"Error: filelength < 0", L"Error", 0 );
    }
    FILE* infp = 0;
	if((infp = _wfopen(szFileName, L"rb")) == (FILE *)NULL) {
                 MessageBoxW( 0, L"Error: open file failed", L"Error", 0 );
             return;
    }
    input_stream_length = ret;
    if (input_data_stream) {
       free(input_data_stream); // no memory leak
    }
    input_data_stream = (unsigned char *)malloc(input_stream_length * sizeof(unsigned char));
    if(input_data_stream == (unsigned char *)NULL) {
       MessageBoxW( 0, L"Error: malloc for input_data_stream failed", L"Error", 0 );
    }
    int n = fread(input_data_stream, sizeof(unsigned char), input_stream_length, infp);
    if(n != input_stream_length) {
         MessageBoxW( 0, L"Error: reading file failed", L"Error", MB_OK );
    }
    fclose(infp);
    close(handle); 



// THE DECODING OF WSQ STREAM INTO DECOMPRESSED STREAM
(pWSQ_decode_stream)(input_data_stream, input_stream_length, &output_data_stream, &width, &height, &ppi, &comment_text);


    //Converts WSQ compressed byte array into HBITMAP for showing on screen
    hBitmap = (pCreateBMPFromWSQByteArray)(input_data_stream, input_stream_length);
    // Saves WSQ compressed byte array to an image file.
    //(pSaveWSQByteArrayToImageFile)(input_data_stream, input_stream_length, "C:\\OutputDirectory\\output.jpg", 5);


   if(input_data_stream != (unsigned char*)NULL)
   {free(input_data_stream); input_data_stream = (unsigned char*)NULL;}


        if ( hBitmap )
        {
// Take and use Handle of HBitmap directly from WSQ image library DLL.
// If the WSQ image library is called to load or save another picture, you will lose the current image
          OutputImage->Picture->Bitmap->Handle = hBitmap;

//Make a copy of hBitmap into OutputImage->Picture
//            OutputImage->Picture->Bitmap->Handle  = (HBITMAP)CopyImage((HANDLE)hBitmap, IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG);

            OutputImage->Width = OutputImage->Picture->Bitmap->Width;
            OutputImage->Height = OutputImage->Picture->Bitmap->Height;
            Invalidate();
        }
        else
        {
            Application->MessageBox("Error: unable to decompress WSQ byte array.", "WSQ library error", MB_OK | MB_ICONERROR );
        }


Application->MessageBox("WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.", "WSQ image library", MB_OK );





    StreamToWSQButton->Enabled = true;



}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StreamToWSQButtonClick(TObject *Sender)
{



	const wchar_t* strFilter = L"WSQ Files (*.wsq)\0*.wsq\0\0";
	wchar_t szFileName[MAX_PATH] = { 0 };
    OPENFILENAMEW ofn;
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = 0;
    ofn.hInstance = 0;
    ofn.lpstrFilter = strFilter;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrDefExt= 0;
    ofn.lpstrFile = szFileName;
    
    if (!GetSaveFileNameW(&ofn)) {
       return ; // cancel open file
    }



bitrate = 0.75;
ppi = 500;
//comment_text2 = NULL;
comment_text2 = "Cognaxon";


   if(input_data_stream2 != (unsigned char*)NULL)
   {free(input_data_stream2); input_data_stream2 = (unsigned char*)NULL;}

   input_data_stream2 = (unsigned char *)malloc((width*height) * sizeof(unsigned char));
   if(input_data_stream2 == (unsigned char *)NULL)
   {MessageBox(NULL, "Error: malloc for input_data_stream2 failed", "Error", MB_OK );}



    int row, row2, pixel_number, pixel_number2;

	// MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
    for (int y = 0; y < height; y++)
    {
        row = width * y;
		row2 = width * (height - y - 1);
        for (int x = 0;  x < width; x++)
        {
         pixel_number = row + x;
		 pixel_number2 = row2 + (width - x - 1);

         input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
        }
    }


// THE ENCODING OF DECOMPRESSED STREAM INTO WSQ STREAM
(pWSQ_encode_stream)(input_data_stream2, width, height, bitrate, ppi, comment_text2, &output_data_stream2, &output_stream2_length);



	wcscat(szFileName, L".wsq");
	// ChangeFileExt(szFileName, L".wsq"); // works only with AnsiString in C++ Builder 2007
    
    FILE* outfp = 0;
    if((outfp = _wfopen(szFileName, L"wb")) == NULL) {
        MessageBoxW(0, L"Error: open file failed", L"Error", 0 );
    }
    int n = 0;
    if((n = fwrite(output_data_stream2, 1, output_stream2_length, outfp)) != output_stream2_length) {
          MessageBoxW(0, L"Error: write to file failed", L"Error", MB_OK );
    }
    fclose(outfp);



MessageBox(NULL, "Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).", "WSQ image library", MB_OK );




}
//---------------------------------------------------------------------------
